#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <ctype.h>

int main(int  argc, char **argv) {
	int i, fd, fdd;
	char *org, *dst;
	struct stat bstat;

	if (argc!=3)  {
		fprintf (stderr, "Uso: %s archivo archivo_destino\n", argv[0]);
		return(1);
	}

	/* Abre el archivo */
	if ((fd=open(argv[1], O_RDONLY))<0) {
		perror("No puede abrirse el archivo");
		return(1);
	}

	/* Averigua la longitud del archivo */
	if (fstat(fd, &bstat)<0) {
		perror("Error en fstat del archivo");
		close(fd);
		return(1);
	}

	/* Se proyecta el archivo */
	if ((org=mmap((caddr_t) 0, bstat.st_size, PROT_READ,
			MAP_SHARED, fd, 0)) == (void *)MAP_FAILED) {
		perror("Error en la proyeccion del archivo");
		close(fd);
		return(1);
	}

	/* Se cierra el archivo */
	close(fd);


	/* Abre el archivo destino */
	if ((fdd=open(argv[2], O_CREAT|O_TRUNC|O_RDWR, 0640))<0) {
		perror("No puede crearse el archivo destino");
		return(1);
	}
	/* Establece longitud archivo destino igual a la del origen.*/
	if (ftruncate(fdd, bstat.st_size)<0) {
		perror("Error en ftruncate del archivo destino");
		close(fdd);
		unlink (argv[2]);
       		return(1);
	}
	/* Se proyecta el archivo destino */
	if ((dst=mmap((caddr_t) 0, bstat.st_size, PROT_WRITE,
			MAP_SHARED, fdd, 0)) == MAP_FAILED) {
		perror("Error en la proyeccion del archivo destino");
		close(fdd);
		unlink (argv[2]);
		return(1);
       	}
	/* Se cierra el archivo */
	close(fdd);
	

	/* Bucle de acceso que sustituye las minsculas por maysculas */
       for (i=0; i<bstat.st_size; i++)
                if (islower(org[i]))
                        dst[i]=toupper(org[i]);
                else
                        dst[i]=org[i];


	/* Se eliminan las proyecciones */
	munmap(org, bstat.st_size);
	munmap(dst, bstat.st_size);

	return(0);
}
