#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>


struct empleado {
	char nombre[32];
	int nhijos;
	// etc.
};

char *fich_plantilla ="plantilla.dat";

int main(int argc, char *argv[]) {
        struct stat bstat;
	int fd, tam, nempl;
	struct empleado *plantilla;

        if (argc < 3) {
                fprintf(stderr, "Uso: %s nombre nhijos...\n", argv[0]);
                return 1;
        }
        /* Abre el archivo */
	if ((fd=open(fich_plantilla, O_RDWR|O_CREAT, 0600))<0) {
                perror("No puede abrirse el archivo");
                return(1);
        }

       /* Averigua la longitud del archivo */
        if (fstat(fd, &bstat)<0) {
                perror("Error en fstat del archivo");
                close(fd);
                return(1);
        }

	/* Habilita sitio para el nuevo empleado */
	tam= bstat.st_size+sizeof(struct empleado);
         if (ftruncate(fd, tam)<0) {
                perror("Error en ftruncate del archivo");
                close(fd);
                return(1);
        }

        /* Se proyecta el archivo */
        if ((plantilla=mmap((caddr_t) 0, tam, PROT_WRITE,
                        MAP_SHARED, fd, 0)) == (void *)MAP_FAILED) {
                perror("Error en la proyeccion del archivo");
                close(fd);
                return(1);
        }

        /* Incluye datos del nuevo empleado */
	nempl=bstat.st_size/sizeof(struct empleado);
	strcpy(plantilla[nempl].nombre, argv[1]);
	plantilla[nempl].nhijos=atoi(argv[2]);

	munmap(plantilla, tam);

	return 0;
}
