#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>

struct casilla {
	int abierta;
	int valor;
};

void init_tablero(int n, struct casilla (*tablero)[n]) {
	int i, j;
	srand(getpid()+time(NULL));
	for (i=0; i<n; i++)
		for (j=0; j<n; j++) {
			tablero[i][j].valor = (int)(((double)rand() * n * n) / RAND_MAX) + 1;
			tablero[i][j].abierta = 0;
		}
}
void print_tablero(int n, struct casilla (*tablero)[n]) {
	int i, j;
	for (i=0; i<n; i++){
		printf("|");
		for (j=0; j<n; j++){
			if (tablero[i][j].abierta)
				printf("%d|", tablero[i][j].valor);
			else
				printf("X|");
		}
		printf("\n");
	}
}

int main(int argc, char *argv[]) {
	int leido;
	unsigned int i, j;
	if (argc != 2) {
		fprintf(stderr, "Uso: %s ncasillas_tablero\n", argv[0]);
		return 1;
	}
	int n = atoi(argv[1]);

	struct casilla (*tablero)[n];

#ifdef ANTIGUO
	tablero = malloc(n * n * sizeof(struct casilla));
	init_tablero(n, tablero);
#else
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
	char *fich_juego ="juego.dat";
	struct stat st;
	int tam = n * n * sizeof(struct casilla);
	int fd, nuevo_juego = 1;
	if (stat(fich_juego, &st) == 0) nuevo_juego = 0;

	if ((fd=open(fich_juego, O_RDWR|O_CREAT, 0600))<0) {
                perror("No puede abrirse el archivo");
                return(1);
        }
	if (!nuevo_juego && (st.st_size != tam)) {
		fprintf(stderr, "Discrepancia en nº casillas con juego activo\n");
		return 1;
	}
	if (nuevo_juego) ftruncate(fd, tam);
	if ((tablero=mmap((caddr_t) 0, tam, PROT_READ|PROT_WRITE,
                        MAP_SHARED, fd, 0)) == (void *)MAP_FAILED) {
                perror("Error en la proyeccion del archivo");
                close(fd);
                return(1);
        }
	if (nuevo_juego) init_tablero(n, tablero);
#endif
	
	do {
		print_tablero(n, tablero);
		printf("\nIntroduzca fila y columna de casilla a destapar (Crtl-D para fin): ");
		leido = scanf("%d%d", &i, &j);
		if (leido ==2 ) {
			if ((i>0) && (i<=n) && (j>0) && (j<=n))
				tablero[--i][--j].abierta = 1;
			else 
				printf("Error en datos introducidos\n");
		}
	} while (leido==2);
	return 0;
}


