#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>

struct casilla {
	int abierta;
	int valor;
};

void init_tablero(int n, struct casilla (*tablero)[n]) {
	int i, j;
	srand(getpid()+time(NULL));
	for (i=0; i<n; i++)
		for (j=0; j<n; j++) {
			tablero[i][j].valor = (int)(((double)rand() * n * n) / RAND_MAX) + 1;
			tablero[i][j].abierta = 0;
		}
}
void print_tablero(int n, struct casilla (*tablero)[n]) {
	int i, j;
	for (i=0; i<n; i++){
		printf("|");
		for (j=0; j<n; j++){
			if (tablero[i][j].abierta)
				printf("%d|", tablero[i][j].valor);
			else
				printf("X|");
		}
		printf("\n");
	}
}

int main(int argc, char *argv[]) {
	int leido;
	unsigned int i, j;
	if (argc != 2) {
		fprintf(stderr, "Uso: %s ncasillas_tablero\n", argv[0]);
		return 1;
	}
	int n = atoi(argv[1]);

	struct casilla (*tablero)[n];

	tablero = malloc(n * n * sizeof(struct casilla));

	init_tablero(n, tablero);
	
	
	do {
		print_tablero(n, tablero);
		printf("\nIntroduzca fila y columna de casilla a destapar (Crtl-D para fin): ");
		leido = scanf("%d%d", &i, &j);
		if (leido ==2 ) {
			if ((i>0) && (i<=n) && (j>0) && (j<=n))
				tablero[--i][--j].abierta = 1;
			else 
				printf("Error en datos introducidos\n");
		}
	} while (leido==2);
	return 0;
}


